'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.preprocessor = undefined;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _inlineSourceMapComment = require('inline-source-map-comment');

var _inlineSourceMapComment2 = _interopRequireDefault(_inlineSourceMapComment);

var _sourceModifier = require('./source-modifier.js');

var _sourceModifier2 = _interopRequireDefault(_sourceModifier);

var _genericMock = require('./generic-mock.js');

var _genericMock2 = _interopRequireDefault(_genericMock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const preprocessor = (events, system, opts) => {
    global.NutraMock = _genericMock2.default;
    events.onLoad = () => {};
    events.onFileLoad = (source, filename, key) => {
        source = (0, _sourceModifier2.default)(source, filename);
        const sourceMapComment = (0, _inlineSourceMapComment2.default)(source.map.toString());
        const sourceWithMap = source.code + '\n' + sourceMapComment;
        const tmpFilename = _path2.default.join(system.tmpDirectory, 'mock', key);

        _fsExtra2.default.ensureFileSync(tmpFilename);
        _fsExtra2.default.writeFileSync(tmpFilename, sourceWithMap);

        return {
            filename: tmpFilename,
            source: source.code,
            key: key
        };
    };
    events.onExit = () => {};
};

exports.preprocessor = preprocessor;